"use strict";
/**
 * @athenna/core
 *
 * (c) João Lenon <lenon@athenna.io>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.AthennaErrorHandler = void 0;
const utils_1 = require("@secjs/utils");
const logger_1 = require("@athenna/logger");
class AthennaErrorHandler {
    // TODO
    // static worker() {}
    // TODO
    // static command() {}
    static http({ error, request, response }) {
        const code = error.code || error.name;
        const statusCode = error.statusCode || error.status || 500;
        const body = {
            code: utils_1.String.toSnakeCase(code).toUpperCase(),
            path: request.baseUrl,
            method: request.method,
            status: statusCode <= 399 ? 'SUCCESS' : 'ERROR',
            statusCode: statusCode,
            error: {
                name: error.name,
                message: error.message,
                stack: error.stack,
            },
        };
        new logger_1.Logger()
            .channel('application')
            .error(`Error: ${JSON.stringify(body.error, null, 2)}`, {
            context: AthennaErrorHandler.name,
        });
        response.status(statusCode).send(body);
    }
}
exports.AthennaErrorHandler = AthennaErrorHandler;
